## mingw-w64-dosbox-staging-0.82.2-1.src.tar.zst

=== src/dos/CMakeLists.txt ===
add_library(libdos STATIC
		cdrom.cpp
		cdrom_image.cpp
		cdrom_ioctl_linux.cpp
		cdrom_win32.cpp
		dos.cpp
		dos_classes.cpp
		dos_devices.cpp
		dos_execute.cpp
		dos_files.cpp
		dos_ioctl.cpp
		dos_keyboard_layout.cpp
		dos_locale.cpp
		dos_memory.cpp
		dos_misc.cpp
		dos_mscdex.cpp
		dos_programs.cpp
		dos_tables.cpp
		drive_cache.cpp
		drive_fat.cpp
		drive_iso.cpp
		drive_local.cpp
		drive_overlay.cpp
		drive_virtual.cpp
		drives.cpp
		program_attrib.cpp
		program_autotype.cpp
		program_biostest.cpp
		program_boot.cpp
		program_choice.cpp
		program_help.cpp
		program_imgmount.cpp
		program_intro.cpp
		program_keyb.cpp
		program_loadfix.cpp
		program_loadrom.cpp
		program_ls.cpp
		program_mem.cpp
		program_mixer.cpp
		program_mode.cpp
		program_more.cpp
		program_more_output.cpp
		program_mount.cpp
		program_mount_common.cpp
		program_mousectl.cpp
		program_move.cpp
		program_placeholder.cpp
		program_rescan.cpp
		program_serial.cpp
		program_setver.cpp
		program_subst.cpp
		program_tree.cpp
)

target_link_libraries(libdos PRIVATE
		libhardware
		libdecoders
		$<IF:$<TARGET_EXISTS:SDL2::SDL2>,SDL2::SDL2,SDL2::SDL2-static>
)

=== src/gui/CMakeLists.txt ===
add_library(libgui STATIC
		render.cpp
		render_scalers.cpp
		sdl_mapper.cpp
		sdlmain.cpp
		shader_manager.cpp
		titlebar.cpp
)

find_package(OpenGL REQUIRED)

target_link_libraries(libgui PRIVATE
		$<IF:$<TARGET_EXISTS:SDL2::SDL2>,SDL2::SDL2,SDL2::SDL2-static>
		OpenGL::GL
)

=== src/ints/CMakeLists.txt ===
add_library(libints STATIC
		bios.cpp
		bios_disk.cpp
		bios_keyboard.cpp
		bios_pci.cpp
		ems.cpp
		int10.cpp
		int10_char.cpp
		int10_memory.cpp
		int10_misc.cpp
		int10_modes.cpp
		int10_pal.cpp
		int10_put_pixel.cpp
		int10_vesa.cpp
		int10_video_state.cpp
		int10_vptable.cpp
		xms.cpp
)

target_link_libraries(libints PRIVATE $<IF:$<TARGET_EXISTS:SDL2::SDL2>,SDL2::SDL2,SDL2::SDL2-static>)

=== src/midi/CMakeLists.txt ===
add_library(libmidi STATIC
		midi.cpp
		midi_alsa.cpp
		midi_fluidsynth.cpp
		midi_mt32.cpp
		midi_lasynth_model.cpp
		midi_oss.cpp
)

find_package(MT32Emu CONFIG REQUIRED)
find_package(FluidSynth CONFIG REQUIRED)

if (C_COREMIDI)
	target_link_libraries(libmidi PRIVATE "-framework CoreFoundation")
	target_link_libraries(libmidi PRIVATE "-framework CoreMIDI")
endif()

target_link_libraries(libmidi PRIVATE
		$<IF:$<TARGET_EXISTS:SDL2::SDL2>,SDL2::SDL2,SDL2::SDL2-static>
		MT32Emu::mt32emu
		FluidSynth::libfluidsynth
)

=== src/misc/CMakeLists.txt ===
add_library(libmisc STATIC
		ansi_code_markup.cpp
		cross.cpp
		ethernet.cpp
		ethernet_slirp.cpp
		fs_utils.cpp
		fs_utils_posix.cpp
		fs_utils_win32.cpp
		help_util.cpp
		messages.cpp
		pacer.cpp
		programs.cpp
		rwqueue.cpp
		setup.cpp
		string_utils.cpp
		support.cpp
		unicode.cpp
)

target_link_libraries(libmisc PRIVATE libwhereami $<IF:$<TARGET_EXISTS:SDL2::SDL2>,SDL2::SDL2,SDL2::SDL2-static>)

=== src/shell/CMakeLists.txt ===
add_library(libshell STATIC
		autoexec.cpp
		command_line.cpp
		file_reader.cpp
		shell.cpp
		shell_batch.cpp
		shell_cmds.cpp
		shell_history.cpp
		shell_misc.cpp
)

target_link_libraries(libshell PRIVATE $<IF:$<TARGET_EXISTS:SDL2::SDL2>,SDL2::SDL2,SDL2::SDL2-static>)

=== src/libs/ESFMu/CMakeLists.txt ===
add_library(libesfmu STATIC
		esfm.c
		esfm_registers.c
)
target_include_directories(libesfmu PUBLIC ..)

=== src/libs/YM7128B_emu/CMakeLists.txt ===
add_library(libym7128bemu STATIC YM7128B_emu.c)
target_include_directories(libym7128bemu PUBLIC .)

=== src/libs/decoders/CMakeLists.txt ===
add_library(libdecoders STATIC
		flac.c
		mp3.cpp
		mp3_seek_table.cpp
		opus.cpp
		SDL_sound.c
		vorbis.c
		wav.c
)

target_include_directories(libdecoders PUBLIC ..)

find_package(OpusFile CONFIG REQUIRED)
target_link_libraries(libdecoders
		PRIVATE
		OpusFile::opusfile
		$<IF:$<TARGET_EXISTS:SDL2::SDL2>,SDL2::SDL2,SDL2::SDL2-static>
)

=== src/libs/tal-chorus/CMakeLists.txt ===
add_library(libtalchorus STATIC Lfo.cpp)
target_include_directories(libtalchorus PUBLIC ..)

=== PKGBUILD ===
# Maintainer: Christoph Reiter <reiter.christoph@gmail.com>

_realname=dosbox-staging
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=0.82.2
pkgrel=1
pkgdesc="Emulator with builtin DOS for running DOS Games (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='https://github.com/dosbox-staging/dosbox-staging'
license=('spdx:GPL-2.0-or-later')
depends=(
    "${MINGW_PACKAGE_PREFIX}-fluidsynth"
    "${MINGW_PACKAGE_PREFIX}-libpng"
    "${MINGW_PACKAGE_PREFIX}-opusfile"
    "${MINGW_PACKAGE_PREFIX}-SDL2"
    "${MINGW_PACKAGE_PREFIX}-SDL2_image"
    "${MINGW_PACKAGE_PREFIX}-SDL2_net"
    "${MINGW_PACKAGE_PREFIX}-zlib"
    "${MINGW_PACKAGE_PREFIX}-libslirp"
    "${MINGW_PACKAGE_PREFIX}-munt-mt32emu"
    "${MINGW_PACKAGE_PREFIX}-speexdsp"
    "${MINGW_PACKAGE_PREFIX}-iir"
)
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-meson"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-pkgconf")
source=("https://github.com/dosbox-staging/dosbox-staging/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz"
        "enet.h::https://github.com/zpl-c/enet/raw/refs/tags/v2.6.5/include/enet.h")
sha256sums=('387c97b373c3164ab5abbbc2b210bf94b5567057abe44ee1e8b4d4e725bd422c'
            '6cb8f4606f064650e46d7d295c19f2885aa94eb07b6222c5c9c97ecf6c493603')
noextract=("${_realname}-${pkgver}.tar.gz")

prepare() {
  bsdtar -xf "${_realname}-${pkgver}.tar.gz" || bsdtar -xf "${_realname}-${pkgver}.tar.gz"

  cd "${_realname}-${pkgver}"
  echo -e "#!python\nprint('${pkgver}')" > scripts/get-version.sh

  # Use newer enet.h v2.6.5 (from https://github.com/zpl-c/enet), because that
  # has some fixes which are not in the older version 2.3.6 used by dosbox-staging
  # and would cause compile errors instead.
  cp ${srcdir}/enet.h src/libs/enet/include/enet.h
}

build() {
  mkdir -p build-${MSYSTEM} && cd build-${MSYSTEM}

  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("--buildtype=release")
  else
    extra_config+=("--buildtype=debug")
  fi

  MSYS2_ARG_CONV_EXCL="--prefix=" \
  ${MINGW_PREFIX}/bin/meson \
    --prefix="${MINGW_PREFIX}" \
    --wrap-mode=nodownload \
    --auto-features=enabled \
    "${extra_config[@]}" \
    -Dunit_tests=disabled \
    -Ddefault_library=shared \
    ../${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/meson compile
}

check() {
  cd "${srcdir}/build-${MSYSTEM}"

  ${MINGW_PREFIX}/bin/meson test
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"

  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/meson install

  install -Dm644 "${srcdir}"/${_realname}-${pkgver}/LICENSE \
    "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE
}

=== contrib/linux/debian/rules ===
#!/usr/bin/make -f
%:
	dh $@ --buildsystem=meson

# Override the following:
#
# 1) Release build because Debian's meson manager will use a
#    'plain' build type, missing out on release-specific settings.
#
# 2) Disable zlib_ng because as a follow-on zlib dependency this
#    also builds a statically linked libpng which is a hard-
#    conflict against Debian's own library (the debian linter
#    scans the binary and detects the embedded library).
#    We can turn this on when Debian adds zlib-ng.
#
# 3) Debian is missing packages for IIR and mt32emu so we
#    build from source and statically link them.
#
# 4) Debian overrides Meson's build flags with less optimizations,
#    So we clobber their override to ensure Debian users get the
#    same performance as the project's other release formats.
#
override_dh_auto_configure:
	dh_auto_configure -- \
		--buildtype=release \
		-Duse_zlib_ng=false \
		-Dtry_static_libs=iir,mt32emu --wrap-mode=default \
		-Dc_args="-g -O3" -Dcpp_args="-g -O3"

override_dh_auto_build:
	dh_auto_build --parallel
